## refpolicy 2.20151208

=== Makefile ===
#
# Makefile for the security policy.
#
# Targets:
# 
# install       - compile and install the policy configuration, and context files.
# load          - compile, install, and load the policy configuration.
# reload        - compile, install, and load/reload the policy configuration.
# relabel       - relabel filesystems based on the file contexts configuration.
# checklabels   - check filesystems against the file context configuration
# restorelabels - check filesystems against the file context configuration
#                 and restore the label of files with incorrect labels
# policy        - compile the policy configuration locally for testing/development.
#
# The default target is 'policy'.
#
#
# Please see build.conf for policy build options.
#

########################################
#
# NO OPTIONS BELOW HERE
#

# Include the local build.conf if it exists, otherwise
# include the configuration of the root directory.
include build.conf

ifdef LOCAL_ROOT
	-include $(LOCAL_ROOT)/build.conf
endif

# refpolicy version
version = $(shell cat VERSION)

ifdef LOCAL_ROOT
builddir := $(LOCAL_ROOT)/
tmpdir := $(LOCAL_ROOT)/tmp
tags := $(LOCAL_ROOT)/tags
else
tmpdir := tmp
tags := tags
endif

# executable paths
BINDIR ?= /usr/bin
SBINDIR ?= /usr/sbin
ifdef TEST_TOOLCHAIN
tc_usrbindir := env LD_LIBRARY_PATH="$(TEST_TOOLCHAIN)/lib:$(TEST_TOOLCHAIN)/usr/lib" $(TEST_TOOLCHAIN)$(BINDIR)
tc_usrsbindir := env LD_LIBRARY_PATH="$(TEST_TOOLCHAIN)/lib:$(TEST_TOOLCHAIN)/usr/lib" $(TEST_TOOLCHAIN)$(SBINDIR)
tc_sbindir := env LD_LIBRARY_PATH="$(TEST_TOOLCHAIN)/lib:$(TEST_TOOLCHAIN)/usr/lib" $(TEST_TOOLCHAIN)/sbin
else
tc_usrbindir := $(BINDIR)
tc_usrsbindir := $(SBINDIR)
tc_sbindir := /sbin
endif
CHECKPOLICY ?= $(tc_usrbindir)/checkpolicy
CHECKMODULE ?= $(tc_usrbindir)/checkmodule
SEMODULE ?= $(tc_usrsbindir)/semodule
SEMOD_PKG ?= $(tc_usrbindir)/semodule_package
SEMOD_LNK ?= $(tc_usrbindir)/semodule_link
SEMOD_EXP ?= $(tc_usrbindir)/semodule_expand
LOADPOLICY ?= $(tc_usrsbindir)/load_policy
SETFILES ?= $(tc_sbindir)/setfiles
XMLLINT ?= $(BINDIR)/xmllint
SECHECK ?= $(BINDIR)/sechecker

# interpreters and aux tools
AWK ?= gawk
GREP ?= egrep
INSTALL ?= install
M4 ?= m4
PYTHON ?= python
SED ?= sed
SORT ?= LC_ALL=C sort
UMASK ?= umask

CFLAGS += -Wall

# policy source layout
poldir := policy
moddir := $(poldir)/modules
flaskdir := $(poldir)/flask
secclass := $(flaskdir)/security_classes
isids := $(flaskdir)/initial_sids
avs := $(flaskdir)/access_vectors

# local source layout
ifdef LOCAL_ROOT
local_poldir := $(LOCAL_ROOT)/policy
local_moddir := $(local_poldir)/modules
endif

# policy building support tools
support := support
genxml := $(PYTHON) -E $(support)/segenxml.py
gendoc := $(PYTHON) -E $(support)/sedoctool.py
genperm := $(PYTHON) -E $(support)/genclassperms.py
policyvers := $(PYTHON) -E $(support)/policyvers.py
fcsort := $(tmpdir)/fc_sort
setbools := $(AWK) -f $(support)/set_bools_tuns.awk
get_type_attr_decl := $(SED) -r -f $(support)/get_type_attr_decl.sed
comment_move_decl := $(SED) -r -f $(support)/comment_move_decl.sed
gennetfilter := $(PYTHON) -E $(support)/gennetfilter.py
m4iferror := $(support)/iferror.m4
m4divert := $(support)/divert.m4
m4undivert := $(support)/undivert.m4
# use our own genhomedircon to make sure we have a known usable one,
# so policycoreutils updates are not required (RHEL4)
genhomedircon := $(PYTHON) -E $(support)/genhomedircon

# documentation paths
docs := doc
xmldtd = $(docs)/policy.dtd
metaxml = metadata.xml
doctemplate = $(docs)/templates
docfiles = $(docs)/Makefile.example $(addprefix $(docs)/,example.te example.if example.fc)

ifndef LOCAL_ROOT
polxml = $(docs)/policy.xml
tunxml = $(docs)/global_tunables.xml
boolxml = $(docs)/global_booleans.xml
htmldir = $(docs)/html
else
polxml = $(LOCAL_ROOT)/doc/policy.xml
tunxml = $(LOCAL_ROOT)/doc/global_tunables.xml
boolxml = $(LOCAL_ROOT)/doc/global_booleans.xml
htmldir = $(LOCAL_ROOT)/doc/html
endif

# config file paths
globaltun = $(poldir)/global_tunables
globalbool = $(poldir)/global_booleans
user_files := $(poldir)/users
policycaps := $(poldir)/policy_capabilities
ctx_defaults := $(poldir)/context_defaults

# local config file paths
ifndef LOCAL_ROOT
mod_conf = $(poldir)/modules.conf
booleans = $(poldir)/booleans.conf
tunables = $(poldir)/tunables.conf
else
mod_conf = $(local_poldir)/modules.conf
booleans = $(local_poldir)/booleans.conf
tunables = $(local_poldir)/tunables.conf
endif

# install paths
PKGNAME ?= refpolicy-$(version)
prefix = $(DESTDIR)/usr
topdir = $(DESTDIR)/etc/selinux
installdir = $(topdir)/$(strip $(NAME))
srcpath = $(installdir)/src
userpath = $(installdir)/users
policypath = $(installdir)/policy
contextpath = $(installdir)/contexts
homedirpath = $(contextpath)/files/homedir_template
fcpath = $(contextpath)/files/file_contexts
fcsubspath = $(contextpath)/files/file_contexts.subs_dist
ncpath = $(contextpath)/netfilter_contexts
sharedir = $(prefix)/share/selinux
modpkgdir = $(sharedir)/$(strip $(NAME))
headerdir = $(modpkgdir)/include
docsdir = $(prefix)/share/doc/$(PKGNAME)

# enable MLS if requested.
ifeq "$(TYPE)" "mls"
	M4PARAM += -D enable_mls
	CHECKPOLICY += -M
	CHECKMODULE += -M
	gennetfilter += -m
endif

# enable MLS if MCS requested.
ifeq "$(TYPE)" "mcs"
	M4PARAM += -D enable_mcs
	CHECKPOLICY += -M
	CHECKMODULE += -M
	gennetfilter += -c
endif

# enable distribution-specific policy
ifneq ($(DISTRO),)
	M4PARAM += -D distro_$(DISTRO)
endif

ifeq "$(DISTRO)" "ubuntu"
	M4PARAM += -D distro_debian
endif

ifeq "$(SYSTEMD)" "y"
	M4PARAM += -D init_systemd
endif

ifneq ($(OUTPUT_POLICY),)
	CHECKPOLICY += -c $(OUTPUT_POLICY)
endif

ifneq "$(CUSTOM_BUILDOPT)" ""
	M4PARAM += $(foreach opt,$(CUSTOM_BUILDOPT),-D $(opt))
endif

# if not set, use the type as the name.
NAME ?= $(TYPE)

# default unknown permissions setting
UNK_PERMS ?= deny

ifeq ($(DIRECT_INITRC),y)
	M4PARAM += -D direct_sysadm_daemon
endif

ifeq "$(UBAC)" "y"
	M4PARAM += -D enable_ubac
endif

# default MLS/MCS sensitivity and category settings.
MLS_SENS ?= 16
MLS_CATS ?= 1024
MCS_CATS ?= 1024

ifeq ($(QUIET),y)
	verbose = @
endif

M4PARAM += -D mls_num_sens=$(MLS_SENS) -D mls_num_cats=$(MLS_CATS) -D mcs_num_cats=$(MCS_CATS) -D hide_broken_symptoms

# we need exuberant ctags; unfortunately it is named
# differently on different distros
ifeq ($(DISTRO),debian)
	CTAGS := ctags-exuberant
endif

ifeq ($(DISTRO),gentoo)
	CTAGS := exuberant-ctags	
endif

CTAGS ?= ctags

m4support := $(m4divert) $(wildcard $(poldir)/support/*.spt)
ifdef LOCAL_ROOT
m4support += $(wildcard $(local_poldir)/support/*.spt)
endif
m4support += $(m4undivert)

appconf := config/appconfig-$(TYPE)
seusers := $(appconf)/seusers
appdir := $(contextpath)
user_default_contexts := $(wildcard config/appconfig-$(TYPE)/*_default_contexts)
user_default_contexts_names := $(addprefix $(contextpath)/users/,$(subst _default_contexts,,$(notdir $(user_default_contexts))))
appfiles := $(addprefix $(appdir)/,default_contexts default_type initrc_context failsafe_context userhelper_context removable_context dbus_contexts sepgsql_contexts x_contexts customizable_types securetty_types virtual_domain_context virtual_image_context) $(contextpath)/files/media $(fcsubspath) $(user_default_contexts_names)
net_contexts := $(builddir)net_contexts

all_layers := $(shell find $(wildcard $(moddir)/*) -maxdepth 0 -type d)
ifdef LOCAL_ROOT
all_layers += $(shell find $(wildcard $(local_moddir)/*) -maxdepth 0 -type d)
endif

generated_te := $(basename $(foreach dir,$(all_layers),$(wildcard $(dir)/*.te.in)))
generated_if := $(basename $(foreach dir,$(all_layers),$(wildcard $(dir)/*.if.in)))
generated_fc := $(basename $(foreach dir,$(all_layers),$(wildcard $(dir)/*.fc.in)))

# sort here since it removes duplicates, which can happen
# when a generated file is already generated
detected_mods := $(sort $(foreach dir,$(all_layers),$(wildcard $(dir)/*.te)) $(generated_te))

modxml := $(addprefix $(tmpdir)/, $(detected_mods:.te=.xml))
layerxml := $(sort $(addprefix $(tmpdir)/, $(notdir $(addsuffix .xml,$(all_layers)))))
layer_names := $(sort $(notdir $(all_layers)))
all_metaxml = $(call detect-metaxml, $(layer_names))

# modules.conf setting for base module
configbase := base

# modules.conf setting for loadable module
configmod := module

# modules.conf setting for unused module
configoff := off

# test for module overrides from command line
mod_test = $(filter $(APPS_OFF), $(APPS_BASE) $(APPS_MODS))
mod_test += $(filter $(APPS_MODS), $(APPS_BASE))
ifneq "$(strip $(mod_test))" ""
        $(error Applications must be base, module, or off, and not in more than one list! $(strip $(mod_test)) found in multiple lists!)
endif

# add on suffix to modules specified on command line
cmdline_base := $(addsuffix .te,$(APPS_BASE))
cmdline_mods := $(addsuffix .te,$(APPS_MODS))
cmdline_off := $(addsuffix .te,$(APPS_OFF))

# extract settings from modules.conf
mod_conf_base := $(addsuffix .te,$(sort $(shell awk '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configbase)") print $$1 }' $(mod_conf) 2> /dev/null)))
mod_conf_mods := $(addsuffix .te,$(sort $(shell awk '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configmod)") print $$1 }' $(mod_conf) 2> /dev/null)))
mod_conf_off := $(addsuffix .te,$(sort $(shell awk '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configoff)") print $$1 }' $(mod_conf) 2> /dev/null)))

base_mods := $(cmdline_base)
mod_mods := $(cmdline_mods)
off_mods := $(cmdline_off)

base_mods += $(filter-out $(cmdline_off) $(cmdline_base) $(cmdline_mods), $(mod_conf_base))
mod_mods += $(filter-out $(cmdline_off) $(cmdline_base) $(cmdline_mods), $(mod_conf_mods))
off_mods += $(filter-out $(cmdline_off) $(cmdline_base) $(cmdline_mods), $(mod_conf_off))

# add modules not in modules.conf to the off list
off_mods += $(filter-out $(base_mods) $(mod_mods) $(off_mods),$(notdir $(detected_mods)))

# filesystems to be used in labeling targets
filesystems = $(shell mount | grep -v "context=" | egrep -v '\((|.*,)bind(,.*|)\)' | awk '/(ext[234]|btrfs| xfs| jfs).*rw/{print $$3}';)
fs_names := "btrfs ext2 ext3 ext4 xfs jfs"

########################################
#
# Functions
#

# detect-metaxml layer_names
ifdef LOCAL_ROOT
define detect-metaxml
	$(shell for i in $1; do \
		if [ -d $(moddir)/$$i -a -d $(local_moddir)/$$i ]; then \
			if [ -f $(local_moddir)/$$i/$(metaxml) ]; then \
				echo $(local_moddir)/$$i/$(metaxml) ;\
			else \
				echo $(moddir)/$$i/$(metaxml) ;\
			fi \
		elif [ -d $(local_moddir)/$$i ]; then
			echo $(local_moddir)/$$i/$(metaxml) ;\
		else \
			echo $(moddir)/$$i/$(metaxml) ;\
		fi \
	done )
endef
else
define detect-metaxml
	$(shell for i in $1; do echo $(moddir)/$$i/$(metaxml); done)
endef
endif

########################################
#
# Load appropriate rules
#

ifeq ($(MONOLITHIC),y)
	include Rules.monolithic
else
	include Rules.modular
endif

########################################
#
# Generated files
#
# NOTE: There is no "local" version of these files.
#
generate: $(generated_te) $(generated_if) $(generated_fc)

$(moddir)/kernel/corenetwork.if: $(moddir)/kernel/corenetwork.te.in $(moddir)/kernel/corenetwork.if.m4 $(moddir)/kernel/corenetwork.if.in
	@echo "#" > $@
	@echo "# This is a generated file!  Instead of modifying this file, the" >> $@
	@echo "# $(notdir $@).in or $(notdir $@).m4 file should be modified." >> $@
	@echo "#" >> $@
	$(verbose) cat $@.in >> $@
	$(verbose) $(GREP) "^[[:blank:]]*network_(interface|node|port|packet)(_controlled)?\(.*\)" $< \
		| $(M4) -D self_contained_policy $(M4PARAM) $(m4divert) $@.m4 $(m4undivert) - \
		| $(SED) -e 's/dollarsone/\$$1/g' -e 's/dollarszero/\$$0/g' >> $@

$(moddir)/kernel/corenetwork.te: $(m4divert) $(moddir)/kernel/corenetwork.te.m4 $(m4undivert) $(moddir)/kernel/corenetwork.te.in
	@echo "#" > $@
	@echo "# This is a generated file!  Instead of modifying this file, the" >> $@
	@echo "# $(notdir $@).in or $(notdir $@).m4 file should be modified." >> $@
	@echo "#" >> $@
	$(verbose) $(M4) -D self_contained_policy $(M4PARAM) $^ \

=== debian/changelog ===
refpolicy (2:2.20151208-1) unstable; urgency=medium

  * Rebase to new upstream
  * Move locallogin, sysadm, udev, and modutils to base
  * Add /lib/systemd to file_contexts.subs_dist and remove duplicate fcontexts
  * Allow unconfined_t to manage all init units
  * Allow dmesg_t and sysadm_t to read /dev/kmsg
  * Label /usr/lib/selinux/hll/pp as bin_t
  * Allow udev_t to create /var/run/network with type net_conf_t
  * Allow auditctl_t to getcap
  * Allow auditd_t setattr on /var/log/audit
  * Allow semanage_t to search policy_src_t dirs for /usr/lib/selinux/hll
  * Label /lib/systemd/libsystemd-shared-.*.so as lib_t
  * Allow systemd_tmpfiles_t and systemd_cgroups_t to read /proc/1/environ
    and /proc/cmdline, and have capability net_admin
  * Allow systemd_tmpfiles_t to create and relabel var_t directories
  * Allow systemd_cgroups_t to send unix dgrams to init.
  * Label /var/run/alsa as alsa_var_lock_t and use type trans for alsa_t to
    create it
  * Allow syslogd_t to create syslogd_var_run_t dirs for
    /run/systemd/journal/streams/
  * Allow alsa_t to manage directories and lnk_files of type alsa_var_lock_t
    for directories under /run/alsa

  * This policy works well for a VM but is known to not work on bare metal.
    I'll upload a new version that fixes this soon.

 -- Russell Coker <russell@coker.com.au>  Wed, 03 Aug 2016 10:42:57 +1000

refpolicy (2:2.20140421-14) jessie; urgency=medium

  * Allow mon_test_t to get RAID status and write to mon_var_lib_t
    Allow mon_test_t to exec mon_test_exec_t (for chained tests)
    Allow mon_test_t to read BIND config files
  * Added auth_read_var_auth(mozilla_t) and allowed mozilla to create mozilla_tmpfs_t
    directories for /var/run/auth/PID/pulse. Allow mozilla_t setcap and exec of
    mozilla_home_t for plugins. Allow mozilla to read vm_sysctls for overcommit memory
    status.
  * Label /usr/bin/boinc as boinc_exec_t and /var/lib/boinc-client(/.*)? as
    boinc_var_lib_t. Allow boinc to exec itself. Allow boinc to exec lib_t.
    Label /var/log/boincerr.log. Allow boinc-client to write to
    /etc/boinc-client/global_prefs_override.xml
    Allow boinc to event_device_t, mouse_device_t, ptmx_t, devpts_t, and
    user_tty_device_t character devices to
    find out when system is idle
  * Merge my stuff with git repository

 -- Russell Coker <russell@coker.com.au>  Tue, 10 May 2016 00:40:21 +1000

refpolicy (2:2.20140421-13) jessie; urgency=medium

  * Allow dovecot_auth_t to get the SE Linux mount point for PAM authentication
  * Allow unconfined domains to get the service status for etc_t.
  * Allow mailman_queue_t to read bin_t symlinks
  * Allow clamd_t and spamass_milter_t to read sysfs_t files
  * Allow system_cronjob_t to read mrtg_etc_t to see if it's enabled
  * Allow httpd_t to send signull to httpd_sys_script_t
    Allow httpd_sys_script_t to read/write stream sockets it inherits from httpd_t
    Allow httpd_t to read httpd_script_exec_type symlinks
  * Allow postgrey_t to read bin_t for perl
  * Label /usr/bin/prosody, /var/run/prosody, /var/lib/prosody, and /var/log/prosody
    as jabber types.
    Allow jabberd_t to exec bin_t (to run env), read usr_t (for lua modules), and
    have netlink read access.
  * Set context for /var/run/spamassassin.pid
  * Allow passwd_t to be in unconfined_r for dpkg to create new users
  * Reserve port 10023 for postgrey too
  * Allow semanage_t to execute a shell for "semanage permissive" commands.
  * Allow ping to read /dev/urandom
  * Make create_chr_file_perms include setattr access for autofs device
  * Allow initrc_t to create and setattr var_run_t dirs
  * Allow initrc_t to create dirs under /dev for /dev/net (needed for 6to4)
  * Allow initrc_t to create tmpfs_t files
  * Added policy for mon network monitoring

 -- Russell Coker <russell@coker.com.au>  Thu, 05 May 2016 16:27:38 +1000

refpolicy (2:2.20140421-12) jessie; urgency=medium

  * Allow init_t to manage init_var_run_t symlinks and self getsched
    to relabel files and dirs to etc_runtime_t for /run/blkid
    to read/write init_var_run_t fifos for /run/initctl
    kernel_rw_unix_sysctls() for setting max_dgram_qlen (and eventually other
    sysctls)
  * Allow restorecond_t and setfiles_t to getattr pstore_t and debugfs_t filesystems
  * Allow kernel_t to setattr/getattr/unlink tty_device_t for kdevtmpfs
  * Label /usr/share/bug/.* files as bin_t for reportbug in strict configuration
  * Label /run/tmpfiles.d/kmod.conf as kmod_var_run_t and allow insmod_t to create it
  * apache_unlink_var_lib() now includes write access to httpd_var_lib_t:dir 
  * Allow apache to read sysctl_vm_t for overcommit_memory
    Allow httpd_sys_script_t to read sysfs_t. allow httpd_t to manage httpd_log_t files
    and directories for mod_pagespeed.
  * Removed bogus .* in mailman file context that was breaking the regex
  * Lots of mailman changes
  * Allow system_mail_t read/write access to crond_tmp_t
  * Allow postfix_pipe_t to write to postfix_public_t sockets
  * Label /usr/share/mdadm/checkarray as bin_t
  * Let systemd_passwd_agent_t, chkpwd_t, and dovecot_auth_t get enforcing status
  * Allow systemd_tmpfiles_t to create the cpu_device_t device
  * Allow init_t to manage init_var_run_t links
  * Allow groupadd_t the fsetid capability
  * Allow dpkg_script_t to transition to passwd_t. Label dpkg-statoverride as
    setfiles_exec_t for changing SE Linux context. Allow setfiles_t to read
    dpkg_var_lib_t so dpkg-statoverride can do it's job
  * Allow initrc_t to write to fsadm_log_t for logsave in strict configuration
  * Allow webalizer to read fonts and allow logrotate to manage webaliser_usage_t files
    also allow it to be run by logrotate_t.
  * Allow jabber to read ssl certs and give it full access to it's log files
    Don't audit jabber running ps.
  * Made logging_search_logs() allow reading var_log_t:lnk_file for symlinks in log dir
  * Allow webalizer to read usr_t and created webalizer_log_t for it's logs


=== debian/control ===
Source: refpolicy
VCS-Git: https://anonscm.debian.org/git/selinux/refpolicy.git
VCS-Browser: https://anonscm.debian.org/gitweb/?p=selinux/refpolicy.git;a=summary
Priority: optional
Section: admin
Homepage: https://github.com/TresysTechnology/refpolicy/wiki
Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
Uploaders: Russell Coker <russell@coker.com.au>
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9)
Build-Depends-Indep: bzip2,
                     checkpolicy (>= 2.4),
                     gawk,
                     libsepol1 (>= 2.4),
                     m4,
                     policycoreutils (>= 2.4),
                     policycoreutils-python-utils (>= 2.4),
                     python

Package: selinux-policy-default
Architecture: all
Depends: libselinux1 (>= 2.4),
         libsemanage1 (>= 2.4),
         libsepol1 (>= 2.4),
         policycoreutils (>= 2.4),
         selinux-utils (>= 2.4),
         ${misc:Depends}
Recommends: checkpolicy, setools
Suggests: logcheck, syslog-summary
Breaks: selinux-basics (<< 0.5.2~)
Description: Strict and Targeted variants of the SELinux policy
 This is the reference policy for SE Linux.  In the default configuration it
 will provide the functionality previously known as the "targeted" policy.  If
 the module "unconfined" is removed then it provides the functionality
 previously known as the "strict" policy.
 .
 This uses the MMCS system of categories.

Package: selinux-policy-mls
Architecture: all
Priority: extra
Depends: libselinux1 (>= 2.4),
         libsemanage1 (>= 2.4),
         libsepol1 (>= 2.4),
         policycoreutils (>= 2.4),
         selinux-utils (>= 2.4),
         ${misc:Depends}
Recommends: checkpolicy, setools
Suggests: logcheck, syslog-summary
Breaks: selinux-basics (<< 0.5.2~)
Description: MLS (Multi Level Security) variant of the SELinux policy
 This is the reference policy for SE Linux built with MLS support.  It allows
 giving data labels such as "Top Secret" and preventing such data from leaking
 to processes or files with lower classification.
 .
 It was developed for Common Criteria LSPP certification for RHEL.  It will
 probably never be well supported in Debian and is only recommended for
 students who want to learn about the security features used by the military.

Package: selinux-policy-src
Architecture: all
Depends: checkpolicy (>= 2.4),
         gawk,
         make,
         policycoreutils (>= 2.4),
         policycoreutils-python-utils (>= 2.4),
         python,
         ${misc:Depends}
Recommends: policycoreutils-dev (>= 2.4), setools
Suggests: logcheck, syslog-summary
Description: Source of the SELinux reference policy for customization
 The SELinux Reference Policy (refpolicy) is a complete SELinux
 policy, as an alternative to the existing strict and targeted
 policies available from http://selinux.sf.net. The goal is to have
 this policy as the system policy, be and used as the basis for
 creating other policies. Refpolicy is based on the current strict and
 targeted policies, but aims to accomplish many additional
 goals:
  + Strong Modularity
  + Clearly stated security Goals
  + Documentation
  + Development Tool Support
  + Forward Looking
  + Configurability
  + Flexible Base Policy
  + Application Policy Variations
  + Multi-Level Security
 .
 This is the source of the policy, provided so that local variations of
 SELinux policy may be created.

Package: selinux-policy-dev
Architecture: all
Depends: checkpolicy (>= 2.4),
         gawk,
         m4,
         make,
         policycoreutils (>= 2.4),
         policycoreutils-dev (>= 2.4),
         policycoreutils-python-utils (>= 2.4),
         python,
         selinux-utils (>= 2.4),
         ${misc:Depends}
Recommends: setools
Description: Headers from the SELinux reference policy for building modules
 The SELinux Reference Policy (refpolicy) is a complete SELinux
 policy, as an alternative to the existing strict and targeted
 policies available from http://selinux.sf.net. The goal is to have
 this policy as the system policy, be and used as the basis for
 creating other policies. Refpolicy is based on the current strict and
 targeted policies, but aims to accomplish many additional
 goals:
  + Strong Modularity
  + Clearly stated security Goals
  + Documentation
  + Development Tool Support
  + Forward Looking
  + Configurability
  + Flexible Base Policy
  + Application Policy Variations
  + Multi-Level Security
 .
 This package provides header files for building your own SELinux
 policy packages compatible with official policy packages.

Package: selinux-policy-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: gcc, make
Conflicts: selinux-policy-refpolicy-doc
Description: Documentation for the SELinux reference policy
 The SELinux Reference Policy (refpolicy) is a complete SELinux
 policy, as an alternative to the existing strict and targeted
 policies available from http://selinux.sf.net. The goal is to have
 this policy as the system policy, be and used as the basis for
 creating other policies. Refpolicy is based on the current strict and
 targeted policies, but aims to accomplish many additional
 goals:
  + Strong Modularity
  + Clearly stated security Goals
  + Documentation
  + Development Tool Support
  + Forward Looking
  + Configurability
  + Flexible Base Policy
  + Application Policy Variations
  + Multi-Level Security
 .
 This package contains the documentation for the reference policy.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

COMMON_OPTIONS = DISTRO=debian DIRECT_INITRC=y MONOLITHIC=n
FLAVOURS = default mls
TYPE_default = mcs
UBAC_default = n
UNK_PERMS_default = allow
TYPE_mls = mls
UBAC_mls = n
UNK_PERMS_mls = deny

BUILD_DATE := $(shell dpkg-parsechangelog --show-field Date)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

%:
	dh $@ --parallel

override_dh_auto_configure: $(patsubst %, conf-%-policy, $(FLAVOURS)) conf-docs conf-src

override_dh_install:
	dh_install --list-missing

override_dh_fixperms:
	dh_fixperms
	chmod +x $(CURDIR)/debian/selinux-policy-dev/usr/share/selinux/devel/include/support/segenxml.py
	chmod 0700 $(CURDIR)/debian/selinux-policy-default/var/lib/selinux/default $(CURDIR)/debian/selinux-policy-mls/var/lib/selinux/mls

override_dh_compress:
	dh_compress
	for flavour in $(FLAVOURS) ; do \
	  for f in $(CURDIR)/debian/selinux-policy-$$flavour/usr/share/selinux/$$flavour/*.pp ; do \
	    bzip2 -9f $$f; \
	  done; \
	done

override_dh_installdeb:
	for flavour in $(FLAVOURS) ; do \
	  sed -e "s/=FLAVOUR=/$$flavour/g" debian/postinst.policy > $(CURDIR)/debian/selinux-policy-$$flavour.postinst; \
	  sed -e "s/=FLAVOUR=/$$flavour/g" debian/postrm.policy > $(CURDIR)/debian/selinux-policy-$$flavour.postrm; \
	done
	dh_installdeb

override_dh_clean:
	dh_clean
	$(MAKE) bare
	for flavour in $(FLAVOURS) ; do \
	  rm -f $(CURDIR)/debian/selinux-policy-$$flavour.postinst; \
	  rm -f $(CURDIR)/debian/selinux-policy-$$flavour.postrm; \
	  rm -rf $(CURDIR)/debian/build-$$flavour; \
	  rm -f build-$$flavour-policy; \
	  rm -f install-$$flavour-policy; \
	  rm -f conf-$$flavour-policy; \
	done
	rm -f install-default-dev;
	rm -rf $(CURDIR)/debian/build-docs;
	rm -rf $(CURDIR)/debian/build-src;
	rm -f support/pyplate.pyc conf-docs install-docs conf-src install-src

override_dh_auto_build: $(patsubst %, build-%-policy, $(FLAVOURS))

override_dh_auto_install: $(patsubst %, install-%-policy, $(FLAVOURS)) install-default-dev install-docs install-src

conf-%-policy:
	test ! -d $(CURDIR)/debian/build-$* ||                             \
            rm -rf $(CURDIR)/debian/build-$*
	mkdir -p    $(CURDIR)/debian/build-$*
	cp -lr policy support Makefile Rules.modular doc                   \
            Rules.monolithic config VERSION Changelog COPYING INSTALL      \
            README man $(CURDIR)/debian/build-$*
	cp debian/build.conf.$* $(CURDIR)/debian/build-$*/build.conf
	$(MAKE) -C $(CURDIR)/debian/build-$*                               \
                   NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) bare
	(cd $(CURDIR)/debian/build-$* ;                            \
           $(MAKE) NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) conf)
	cp debian/modules.conf.$*                                          \
                     $(CURDIR)/debian/build-$*/policy/modules.conf
	touch $@

conf-docs:
	test ! -d $(CURDIR)/debian/build-docs ||                   \
           rm -rf $(CURDIR)/debian/build-docs
	mkdir -p    $(CURDIR)/debian/build-docs
	cp -lr policy support Makefile Rules.modular doc                \
                Rules.monolithic config VERSION Changelog COPYING INSTALL   \
                README man $(CURDIR)/debian/build-docs
	cp  debian/build.conf.default $(CURDIR)/debian/build-docs/build.conf
	(cd $(CURDIR)/debian/build-docs ;                          \
           $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) conf)
	touch $@

conf-src:
	test ! -d $(CURDIR)/debian/build-src ||                  \
	    rm -rf $(CURDIR)/debian/build-src
	mkdir -p    $(CURDIR)/debian/build-src
	cp -lr policy support Makefile Rules.modular  doc               \
	       Rules.monolithic config VERSION Changelog COPYING INSTALL  \
	        README man $(CURDIR)/debian/build-src
	cp  debian/build.conf.default $(CURDIR)/debian/build-src/build.conf
	(cd $(CURDIR)/debian/build-src ;                         \
	   $(MAKE) NAME=default $(OPTIONS) conf)
	cp debian/modules.conf.*      $(CURDIR)/debian/build-src/policy/
	cp debian/build.conf.default $(CURDIR)/debian/build-src/policy/
	touch $@


build-%-policy: conf-%-policy
	(cd $(CURDIR)/debian/build-$* ;                          \
             $(MAKE) NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) policy)
	touch $@

install-%-policy: build-%-policy
	(cd $(CURDIR)/debian/build-$*; \
	    $(MAKE) NAME=$* TYPE=$(TYPE_$*) UBAC=$(UBAC_$*) UNK_PERMS=$(UNK_PERMS_$*) $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp install)
	cp -a debian/setrans.conf.$* $(CURDIR)/debian/tmp/etc/selinux/$*/setrans.conf
	mkdir -p $(CURDIR)/debian/tmp/etc/selinux/$*/contexts/files/
	mkdir -p $(CURDIR)/debian/tmp/etc/selinux/$*/policy/
	mkdir -p $(CURDIR)/debian/tmp/var/lib/selinux/$*
# Create a list with the modules we are shipping
	(cd $(CURDIR)/debian/tmp/usr/share/selinux/$*; LC_ALL=C ls -1 | cut -d. -f1 > .modules)
	touch $@

# The headers are based on the default policy
install-default-dev: build-default-policy
	(cd $(CURDIR)/debian/build-default; \
	    $(MAKE) NAME=default TYPE=$(TYPE_default) UBAC=$(UBAC_default) UNK_PERMS=$(UNK_PERMS_default) $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp install-headers)
	mkdir -p $(CURDIR)/debian/tmp/usr/share/selinux/devel/
	mv $(CURDIR)/debian/tmp/usr/share/selinux/default/include $(CURDIR)/debian/tmp/usr/share/selinux/devel/
	cp -a $(CURDIR)/debian/build-default/doc/policy.dtd $(CURDIR)/debian/tmp/usr/share/selinux/devel/
	cp -a $(CURDIR)/debian/build-default/doc/policy.xml $(CURDIR)/debian/tmp/usr/share/selinux/devel/
	grep -v genfscon.selinuxfs $(CURDIR)/debian/tmp/usr/share/selinux/devel/include/kernel/selinux.if > $(CURDIR)/debian/tmp/usr/share/selinux/devel/include/kernel/selinux.if.new
	mv $(CURDIR)/debian/tmp/usr/share/selinux/devel/include/kernel/selinux.if.new $(CURDIR)/debian/tmp/usr/share/selinux/devel/include/kernel/selinux.if
	cp -a $(CURDIR)/debian/Makefile.devel $(CURDIR)/debian/tmp/usr/share/selinux/devel/Makefile
	touch $@

install-docs: conf-docs
	(cd $(CURDIR)/debian/build-docs; \
	    $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp/ PKGNAME=selinux-policy-doc conf \
	    $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp/ PKGNAME=selinux-policy-doc html \
	    $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp/ PKGNAME=selinux-policy-doc install-docs)
	touch $@

install-src: conf-src
	mkdir -p    $(CURDIR)/debian/tmp/usr/src
	(cd $(CURDIR)/debian/build-src;                                 \
	 $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp/ bare; \
	 $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp/ conf; \
	 $(MAKE) NAME=default TYPE=mcs UBAC=n UNK_PERMS=allow $(COMMON_OPTIONS) DESTDIR=$(CURDIR)/debian/tmp/ install-src; )
	find $(CURDIR)/debian/tmp -type d -name .arch-ids -print0 | xargs -0r rm -rf
	test ! -e $(CURDIR)/debian/tmp/etc/selinux/default/src/policy/COPYING || \
	   rm -f $(CURDIR)/debian/tmp/etc/selinux/default/src/policy/COPYING
	rm -rf   $(CURDIR)/debian/tmp/etc/selinux/default/src/policy/man
	(cd $(CURDIR)/debian/tmp/etc/selinux/default/src/policy;                   \
	  if test -f modules.conf; then                                   \
	      mv modules.conf modules.conf.dist;                          \
	  fi;                                                             \
	  ln -sf modules.conf.mls modules.conf)
	install -p -o root -g root -m 644      debian/build.conf.default                   \
	                     $(CURDIR)/debian/tmp/etc/selinux/default/src/policy/build.conf

## refpolicy 2.20161023.1

=== Makefile ===
--- 
+++ 
@@ -250,7 +250,7 @@
 appdir := $(contextpath)
 user_default_contexts := $(wildcard config/appconfig-$(TYPE)/*_default_contexts)
 user_default_contexts_names := $(addprefix $(contextpath)/users/,$(subst _default_contexts,,$(notdir $(user_default_contexts))))
-appfiles := $(addprefix $(appdir)/,default_contexts default_type initrc_context failsafe_context userhelper_context removable_context dbus_contexts sepgsql_contexts x_contexts customizable_types securetty_types virtual_domain_context virtual_image_context) $(contextpath)/files/media $(fcsubspath) $(user_default_contexts_names)
+appfiles := $(addprefix $(appdir)/,default_contexts default_type initrc_context failsafe_context userhelper_context removable_context dbus_contexts sepgsql_contexts x_contexts customizable_types securetty_types lxc_contexts virtual_domain_context virtual_image_context) $(contextpath)/files/media $(fcsubspath) $(user_default_contexts_names)
 net_contexts := $(builddir)net_contexts
 
 all_layers := $(shell find $(wildcard $(moddir)/*) -maxdepth 0 -type d)
@@ -293,9 +293,9 @@
 cmdline_off := $(addsuffix .te,$(APPS_OFF))
 
 # extract settings from modules.conf
-mod_conf_base := $(addsuffix .te,$(sort $(shell awk '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configbase)") print $$1 }' $(mod_conf) 2> /dev/null)))
-mod_conf_mods := $(addsuffix .te,$(sort $(shell awk '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configmod)") print $$1 }' $(mod_conf) 2> /dev/null)))
-mod_conf_off := $(addsuffix .te,$(sort $(shell awk '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configoff)") print $$1 }' $(mod_conf) 2> /dev/null)))
+mod_conf_base := $(addsuffix .te,$(sort $(shell $(AWK) '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configbase)") print $$1 }' $(mod_conf) 2> /dev/null)))
+mod_conf_mods := $(addsuffix .te,$(sort $(shell $(AWK) '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configmod)") print $$1 }' $(mod_conf) 2> /dev/null)))
+mod_conf_off := $(addsuffix .te,$(sort $(shell $(AWK) '/^[[:blank:]]*[[:alpha:]]/{ if ($$3 == "$(configoff)") print $$1 }' $(mod_conf) 2> /dev/null)))
 
 base_mods := $(cmdline_base)
 mod_mods := $(cmdline_mods)
@@ -309,7 +309,7 @@
 off_mods += $(filter-out $(base_mods) $(mod_mods) $(off_mods),$(notdir $(detected_mods)))
 
 # filesystems to be used in labeling targets
-filesystems = $(shell mount | grep -v "context=" | egrep -v '\((|.*,)bind(,.*|)\)' | awk '/(ext[234]|btrfs| xfs| jfs).*rw/{print $$3}';)
+filesystems = $(shell mount | grep -v "context=" | egrep -v '\((|.*,)bind(,.*|)\)' | $(AWK) '/(ext[234]|btrfs| xfs| jfs).*rw/{print $$3}';)
 fs_names := "btrfs ext2 ext3 ext4 xfs jfs"
 
 ########################################
@@ -374,4 +374,3 @@
 	@echo "# This is a generated file!  Instead of modifying this file, the" >> $@
 	@echo "# $(notdir $@).in or $(notdir $@).m4 file should be modified." >> $@
 	@echo "#" >> $@
-	$(verbose) $(M4) -D self_contained_policy $(M4PARAM) $^ \

=== debian/changelog ===
refpolicy (2:2.20161023.1-9) unstable; urgency=medium

  * Dontaudit dkim_milter_t binding to labeled udp ports
  * Allow passwd_t to inherit fd from unconfined_t for package scripts
  * Allow httpd_sys_script_t to talk to itself via unix datagrams and send
    syslog messages
  * Allow logwatch_mail_t to rw system_cronjob_t pipes
    Allow logwatch_t to run mdadm
  * Label /etc/postfixadmin as httpd_config_t
  * Allow system_cronjob_t to create directories under /tmp
  * Allow spamass_milter_t to read the overcommit sysctl
  * Allow unconfined domains the capability2:wake_alarm.
  * Added ~/DovecotMail to the list of mail_home_rw_t directories
  * Allow systemd_logind_t to get dpkg_script_t process state and talk to it
    via dbus
  * For https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=851933 allow udev_t
    to read default_t.  Still need that udev bug fixed!

 -- Russell Coker <russell@coker.com.au>  Thu, 26 Jan 2017 00:52:00 +1100

refpolicy (2:2.20161023.1-8) unstable; urgency=medium

  * Fixed mistake in previous changelog (attributed a -7 change to -6)
  * Label /usr/sbin/apache2ctl as well. Allow apache to read overcommit sysctl
  * Allow clamd_t to read the overcommit sysctl
  * Allow postfix_postdrop_t to write to postfix_public_t socket, allow
    postfix_master_t to bind to udp generic nodes
  * Allow dovecot_auth_t to write to dovecot_var_run_t fifos and read selinux
    config (needed for pop/imap login)
  * Allow mon local tests to search /var/spool/postfix and autofs mountpoints,
    and to read nfs content. Allow mon net tests to read certs. dontaudit when
    mon local tests try to stat tmpfs files. Allow mon local tests to access
    /dev/xconsole and search mnt_t and boot_t
  * Allow mount_t to getattr nfs filesystems and manage mount_var_run_t dirs
    and files
  * Allow setfiles_t to getattr nfs filesystems.
  * Allow postgrey_t to exec bin_t files, to read netlink_route_sockets,
    and to access udp sockets
  * Allow login programs to share fds with systemd_passwd_agent_t
  * Allow postfix_master_t to stat the spamass_milter_data_t dir
  * Allow dpkg_script_t to tell init_t to stop services
  * Allow initrc_t to tell init_t to halt and get system status - allows
    poweroff!!!
  * Make port 8953 be rndc type for unbound.
  * Lots of policy for systemd_nspawn_t
  * More policy for systemd_coredump_t to do what it wants
  * Allow dkim_milter_t to read vm overcommit sysctl
  * Allow mandb_t to search init pid dirs for systemd
  * Allow initrc_t to reload systemdunit types
  * Make init_manage_all_units() include file:getattr access
  * Allow logrotate to init_manage_all_units for restarting daemons, to stat
    tmpfs filesystems, to get init system status, and capability net_admin
    that systemctl wants
  * Allow network manager to inherit logind pids
  * Allow devicekit_power_t to search init pid dirs
  * Allow named to read vm sysctls
  * Allow mysqld_safe_t to read dpkg db, it inherits cwd from dpkg_script_t
    alow is to read sysfs and kill mysqld_t
    Make mysql_signal interface include signull permission and grant that to
    logrotate
  * Allow rpcd_t to write /proc/fs/lockd/nlm_end_grace
  * Make apache use the new interfaces for nfs access and to read
    httpd_var_lib_t symlinks. Allow httpd_sys_script_t to search init pid
    dirs
  * Allow auth to send sigchild to xdm
  * Allow chkpwd_t to getattr the selinuxfs
  * Allow system_cronjob_t net_admin capability, manage acct data, and manage
    initrc services
  * Allow crontab domains fsetid capability. Use a separate $2_crontab_t domain
    for each role's crontab program. Give ntp_admin access to system_cronjob_t
    and allow it to manage var_log_t and cron log files
  * Label /var/lib/sddm as xdm_var_lib_t
  * Don't label acct cron job scripts as acct_exec_t
  * Allow systemd-tmpfiles to create /dev/xconsole
  * Create new type for /var/run/iodine
  * Allow logrotate to restart services
  * Made init_script_service_restart() include reload access
  * Dontaudit systemd_logind_t statting files under /dev/shm
    Allow it to setattr unallocated terminals and unlink user_runtime_t files
  * Added boolean allow_smbd_read_shadow for the obvious purpose
    Allow smbd_t to read cupsd_var_run_t socket as well as write to it
  * Allow NetworkManager_t to send dbus messages to unconfined_t
  * Grant access to dri and input_dev devices to system_dbusd_t, gdm3 makes it
    want this

 -- Russell Coker <russell@coker.com.au>  Mon, 23 Jan 2017 01:55:57 +1100

refpolicy (2:2.20161023.1-7) unstable; urgency=medium
    
  [ Laurent Bigonville and cgzones ]
   * Sort the files in the files in the selinux-policy-src.tar.gz tarball by
     name, this should fix the last issue for reproducible build
   * Add genfscon for cpu/online. Closes: #849637
  [ Russell Coker ]
   * Make the boinc patch like the one upstream accepted and make it last in
     the list.
   * Label /etc/sddm/Xsession as xsession_exec_t
   * Label ~/.xsession-errors as xauth_home_t and use a type-trans rule for it
   * Allow devicekit_power_t to chat to xdm_t via dbus
   * Allow rtkit_daemon_t to stat the selinuxfs and seach default contexts
   * Allow loadkeys_t to read tmp files created by init scripts
   * Allow systemd_tmpfiles_t to delete usr_t files for a file copied to /tmp
     and to read dbus lib files for /var/lib/dbus
   * Allow systemd_logind_t to list tmpfs_t dirs, relabelto user runtime,
     relabel to/from user_tmpfs_t, and manage wireless_device_t
   * Allow xauth_t to inherit file handles from xdm_t, read an inherited fifo
     and read/write an inherited socket.
   * Allow xdm_t to send dbus messages to unconfined_t
   * Give crond_t sys_resource so it can set hard ulimit for jobs
   * Allow systemd_logind_t to setattr on the kvm device and user ttys, to
     manage user_tmp_t and user_tmpfs_t files, to read/write the dri device
   * Allow systemd_passwd_agent_t to stat the selinuxfs and search the
     contexts dir


=== debian/control ===
--- 
+++ 
@@ -9,25 +9,29 @@
 Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9)
 Build-Depends-Indep: bzip2,
-                     checkpolicy (>= 2.4),
+                     checkpolicy (>= 2.5),
                      gawk,
-                     libsepol1 (>= 2.4),
+                     libsepol1 (>= 2.5),
                      m4,
-                     policycoreutils (>= 2.4),
-                     policycoreutils-python-utils (>= 2.4),
-                     python
+                     policycoreutils (>= 2.5),
+                     policycoreutils-python-utils (>= 2.5),
+                     python,
+# Needed for the --sort=name option, can probably be removed when this version
+# hits stable.
+                     tar (>= 1.28)
 
 Package: selinux-policy-default
 Architecture: all
-Depends: libselinux1 (>= 2.4),
-         libsemanage1 (>= 2.4),
-         libsepol1 (>= 2.4),
-         policycoreutils (>= 2.4),
-         selinux-utils (>= 2.4),
+Depends: libselinux1 (>= 2.5),
+         libsemanage1 (>= 2.5),
+         libsepol1 (>= 2.5),
+         policycoreutils (>= 2.5),
+         selinux-utils (>= 2.5),
          ${misc:Depends}
 Recommends: checkpolicy, setools
 Suggests: logcheck, syslog-summary
 Breaks: selinux-basics (<< 0.5.2~)
+Conflicts: mcstrans
 Description: Strict and Targeted variants of the SELinux policy
  This is the reference policy for SE Linux.  In the default configuration it
  will provide the functionality previously known as the "targeted" policy.  If
@@ -48,6 +52,7 @@
 Recommends: checkpolicy, setools
 Suggests: logcheck, syslog-summary
 Breaks: selinux-basics (<< 0.5.2~)
+Conflicts: mcstrans
 Description: MLS (Multi Level Security) variant of the SELinux policy
  This is the reference policy for SE Linux built with MLS support.  It allows
  giving data labels such as "Top Secret" and preventing such data from leaking

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
-COMMON_OPTIONS = DISTRO=debian DIRECT_INITRC=y MONOLITHIC=n
+COMMON_OPTIONS = DISTRO=debian DIRECT_INITRC=y MONOLITHIC=n SYSTEMD=y
 FLAVOURS = default mls
 TYPE_default = mcs
 UBAC_default = n
@@ -23,7 +23,7 @@
 override_dh_auto_configure: $(patsubst %, conf-%-policy, $(FLAVOURS)) conf-docs conf-src
 
 override_dh_install:
-	dh_install --list-missing
+	dh_install --fail-missing
 
 override_dh_fixperms:
 	dh_fixperms
@@ -122,6 +122,7 @@
 	mkdir -p $(CURDIR)/debian/tmp/var/lib/selinux/$*
 # Create a list with the modules we are shipping
 	(cd $(CURDIR)/debian/tmp/usr/share/selinux/$*; LC_ALL=C ls -1 | cut -d. -f1 > .modules)
+	(cd $(CURDIR)/debian/tmp/usr/share/selinux/$*; grep -P '^[a-z0-9_]+\s*=\s*base$$' $(CURDIR)/debian/build-$*/policy/modules.conf | cut -d= -f1 | awk '{$$1=$$1};1' | LC_ALL=C sort > .basemodules)
 	touch $@
 
 # The headers are based on the default policy
@@ -159,5 +160,3 @@
 	      mv modules.conf modules.conf.dist;                          \
 	  fi;                                                             \
 	  ln -sf modules.conf.mls modules.conf)
-	install -p -o root -g root -m 644      debian/build.conf.default                   \
-	                     $(CURDIR)/debian/tmp/etc/selinux/default/src/policy/build.conf
